t / test-lib.shon commit push: pass --progress down to git-pack-objects (d7c411b)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset GIT_EDITOR
  47unset AUTHOR_DATE
  48unset AUTHOR_EMAIL
  49unset AUTHOR_NAME
  50unset COMMIT_AUTHOR_EMAIL
  51unset COMMIT_AUTHOR_NAME
  52unset EMAIL
  53unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  54unset GIT_AUTHOR_DATE
  55GIT_AUTHOR_EMAIL=author@example.com
  56GIT_AUTHOR_NAME='A U Thor'
  57unset GIT_COMMITTER_DATE
  58GIT_COMMITTER_EMAIL=committer@example.com
  59GIT_COMMITTER_NAME='C O Mitter'
  60unset GIT_DIFF_OPTS
  61unset GIT_DIR
  62unset GIT_WORK_TREE
  63unset GIT_EXTERNAL_DIFF
  64unset GIT_INDEX_FILE
  65unset GIT_OBJECT_DIRECTORY
  66unset GIT_CEILING_DIRECTORIES
  67unset SHA1_FILE_DIRECTORIES
  68unset SHA1_FILE_DIRECTORY
  69unset GIT_NOTES_REF
  70unset GIT_NOTES_DISPLAY_REF
  71unset GIT_NOTES_REWRITE_REF
  72unset GIT_NOTES_REWRITE_MODE
  73GIT_MERGE_VERBOSITY=5
  74export GIT_MERGE_VERBOSITY
  75export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  76export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  77export EDITOR
  78
  79# Protect ourselves from common misconfiguration to export
  80# CDPATH into the environment
  81unset CDPATH
  82
  83unset GREP_OPTIONS
  84
  85case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  86        1|2|true)
  87                echo "* warning: Some tests will not work if GIT_TRACE" \
  88                        "is set as to trace on STDERR ! *"
  89                echo "* warning: Please set GIT_TRACE to something" \
  90                        "other than 1, 2 or true ! *"
  91                ;;
  92esac
  93
  94# Convenience
  95#
  96# A regexp to match 5 and 40 hexdigits
  97_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  98_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  99
 100# Each test should start with something like this, after copyright notices:
 101#
 102# test_description='Description of this test...
 103# This test checks if command xyzzy does the right thing...
 104# '
 105# . ./test-lib.sh
 106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 107                TERM=$ORIGINAL_TERM &&
 108                export TERM &&
 109                [ -t 1 ] &&
 110                tput bold >/dev/null 2>&1 &&
 111                tput setaf 1 >/dev/null 2>&1 &&
 112                tput sgr0 >/dev/null 2>&1
 113        ) &&
 114        color=t
 115
 116while test "$#" -ne 0
 117do
 118        case "$1" in
 119        -d|--d|--de|--deb|--debu|--debug)
 120                debug=t; shift ;;
 121        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 122                immediate=t; shift ;;
 123        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 124                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 125        -h|--h|--he|--hel|--help)
 126                help=t; shift ;;
 127        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 128                verbose=t; shift ;;
 129        -q|--q|--qu|--qui|--quie|--quiet)
 130                # Ignore --quiet under a TAP::Harness. Saying how many tests
 131                # passed without the ok/not ok details is always an error.
 132                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 133        --with-dashes)
 134                with_dashes=t; shift ;;
 135        --no-color)
 136                color=; shift ;;
 137        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 138                valgrind=t; verbose=t; shift ;;
 139        --tee)
 140                shift ;; # was handled already
 141        --root=*)
 142                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 143                shift ;;
 144        *)
 145                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 146        esac
 147done
 148
 149if test -n "$color"; then
 150        say_color () {
 151                (
 152                TERM=$ORIGINAL_TERM
 153                export TERM
 154                case "$1" in
 155                        error) tput bold; tput setaf 1;; # bold red
 156                        skip)  tput bold; tput setaf 2;; # bold green
 157                        pass)  tput setaf 2;;            # green
 158                        info)  tput setaf 3;;            # brown
 159                        *) test -n "$quiet" && return;;
 160                esac
 161                shift
 162                printf "%s" "$*"
 163                tput sgr0
 164                echo
 165                )
 166        }
 167else
 168        say_color() {
 169                test -z "$1" && test -n "$quiet" && return
 170                shift
 171                echo "$*"
 172        }
 173fi
 174
 175error () {
 176        say_color error "error: $*"
 177        GIT_EXIT_OK=t
 178        exit 1
 179}
 180
 181say () {
 182        say_color info "$*"
 183}
 184
 185test "${test_description}" != "" ||
 186error "Test script did not set test_description."
 187
 188if test "$help" = "t"
 189then
 190        echo "$test_description"
 191        exit 0
 192fi
 193
 194exec 5>&1
 195if test "$verbose" = "t"
 196then
 197        exec 4>&2 3>&1
 198else
 199        exec 4>/dev/null 3>/dev/null
 200fi
 201
 202test_failure=0
 203test_count=0
 204test_fixed=0
 205test_broken=0
 206test_success=0
 207
 208test_external_has_tap=0
 209
 210die () {
 211        code=$?
 212        if test -n "$GIT_EXIT_OK"
 213        then
 214                exit $code
 215        else
 216                echo >&5 "FATAL: Unexpected exit with code $code"
 217                exit 1
 218        fi
 219}
 220
 221GIT_EXIT_OK=
 222trap 'die' EXIT
 223
 224# The semantics of the editor variables are that of invoking
 225# sh -c "$EDITOR \"$@\"" files ...
 226#
 227# If our trash directory contains shell metacharacters, they will be
 228# interpreted if we just set $EDITOR directly, so do a little dance with
 229# environment variables to work around this.
 230#
 231# In particular, quoting isn't enough, as the path may contain the same quote
 232# that we're using.
 233test_set_editor () {
 234        FAKE_EDITOR="$1"
 235        export FAKE_EDITOR
 236        EDITOR='"$FAKE_EDITOR"'
 237        export EDITOR
 238}
 239
 240test_decode_color () {
 241        sed     -e 's/.\[1m/<WHITE>/g' \
 242                -e 's/.\[31m/<RED>/g' \
 243                -e 's/.\[32m/<GREEN>/g' \
 244                -e 's/.\[33m/<YELLOW>/g' \
 245                -e 's/.\[34m/<BLUE>/g' \
 246                -e 's/.\[35m/<MAGENTA>/g' \
 247                -e 's/.\[36m/<CYAN>/g' \
 248                -e 's/.\[m/<RESET>/g'
 249}
 250
 251q_to_nul () {
 252        perl -pe 'y/Q/\000/'
 253}
 254
 255q_to_cr () {
 256        tr Q '\015'
 257}
 258
 259q_to_tab () {
 260        tr Q '\011'
 261}
 262
 263append_cr () {
 264        sed -e 's/$/Q/' | tr Q '\015'
 265}
 266
 267remove_cr () {
 268        tr '\015' Q | sed -e 's/Q$//'
 269}
 270
 271test_tick () {
 272        if test -z "${test_tick+set}"
 273        then
 274                test_tick=1112911993
 275        else
 276                test_tick=$(($test_tick + 60))
 277        fi
 278        GIT_COMMITTER_DATE="$test_tick -0700"
 279        GIT_AUTHOR_DATE="$test_tick -0700"
 280        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 281}
 282
 283# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 284#
 285# This will commit a file with the given contents and the given commit
 286# message.  It will also add a tag with <message> as name.
 287#
 288# Both <file> and <contents> default to <message>.
 289
 290test_commit () {
 291        file=${2:-"$1.t"}
 292        echo "${3-$1}" > "$file" &&
 293        git add "$file" &&
 294        test_tick &&
 295        git commit -m "$1" &&
 296        git tag "$1"
 297}
 298
 299# Call test_merge with the arguments "<message> <commit>", where <commit>
 300# can be a tag pointing to the commit-to-merge.
 301
 302test_merge () {
 303        test_tick &&
 304        git merge -m "$1" "$2" &&
 305        git tag "$1"
 306}
 307
 308# This function helps systems where core.filemode=false is set.
 309# Use it instead of plain 'chmod +x' to set or unset the executable bit
 310# of a file in the working directory and add it to the index.
 311
 312test_chmod () {
 313        chmod "$@" &&
 314        git update-index --add "--chmod=$@"
 315}
 316
 317# Use test_set_prereq to tell that a particular prerequisite is available.
 318# The prerequisite can later be checked for in two ways:
 319#
 320# - Explicitly using test_have_prereq.
 321#
 322# - Implicitly by specifying the prerequisite tag in the calls to
 323#   test_expect_{success,failure,code}.
 324#
 325# The single parameter is the prerequisite tag (a simple word, in all
 326# capital letters by convention).
 327
 328test_set_prereq () {
 329        satisfied="$satisfied$1 "
 330}
 331satisfied=" "
 332
 333test_have_prereq () {
 334        # prerequisites can be concatenated with ','
 335        save_IFS=$IFS
 336        IFS=,
 337        set -- $*
 338        IFS=$save_IFS
 339
 340        total_prereq=0
 341        ok_prereq=0
 342        missing_prereq=
 343
 344        for prerequisite
 345        do
 346                total_prereq=$(($total_prereq + 1))
 347                case $satisfied in
 348                *" $prerequisite "*)
 349                        ok_prereq=$(($ok_prereq + 1))
 350                        ;;
 351                *)
 352                        # Keep a list of missing prerequisites
 353                        if test -z "$missing_prereq"
 354                        then
 355                                missing_prereq=$prerequisite
 356                        else
 357                                missing_prereq="$prerequisite,$missing_prereq"
 358                        fi
 359                esac
 360        done
 361
 362        test $total_prereq = $ok_prereq
 363}
 364
 365test_declared_prereq () {
 366        case ",$test_prereq," in
 367        *,$1,*)
 368                return 0
 369                ;;
 370        esac
 371        return 1
 372}
 373
 374# You are not expected to call test_ok_ and test_failure_ directly, use
 375# the text_expect_* functions instead.
 376
 377test_ok_ () {
 378        test_success=$(($test_success + 1))
 379        say_color "" "ok $test_count - $@"
 380}
 381
 382test_failure_ () {
 383        test_failure=$(($test_failure + 1))
 384        say_color error "not ok - $test_count $1"
 385        shift
 386        echo "$@" | sed -e 's/^/#       /'
 387        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 388}
 389
 390test_known_broken_ok_ () {
 391        test_fixed=$(($test_fixed+1))
 392        say_color "" "ok $test_count - $@ # TODO known breakage"
 393}
 394
 395test_known_broken_failure_ () {
 396        test_broken=$(($test_broken+1))
 397        say_color skip "not ok $test_count - $@ # TODO known breakage"
 398}
 399
 400test_debug () {
 401        test "$debug" = "" || eval "$1"
 402}
 403
 404test_run_ () {
 405        test_cleanup=:
 406        eval >&3 2>&4 "$1"
 407        eval_ret=$?
 408        eval >&3 2>&4 "$test_cleanup"
 409        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 410                echo ""
 411        fi
 412        return 0
 413}
 414
 415test_skip () {
 416        test_count=$(($test_count+1))
 417        to_skip=
 418        for skp in $GIT_SKIP_TESTS
 419        do
 420                case $this_test.$test_count in
 421                $skp)
 422                        to_skip=t
 423                        break
 424                esac
 425        done
 426        if test -z "$to_skip" && test -n "$test_prereq" &&
 427           ! test_have_prereq "$test_prereq"
 428        then
 429                to_skip=t
 430        fi
 431        case "$to_skip" in
 432        t)
 433                of_prereq=
 434                if test "$missing_prereq" != "$test_prereq"
 435                then
 436                        of_prereq=" of $test_prereq"
 437                fi
 438
 439                say_color skip >&3 "skipping test: $@"
 440                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 441                : true
 442                ;;
 443        *)
 444                false
 445                ;;
 446        esac
 447}
 448
 449test_expect_failure () {
 450        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 451        test "$#" = 2 ||
 452        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 453        export test_prereq
 454        if ! test_skip "$@"
 455        then
 456                say >&3 "checking known breakage: $2"
 457                test_run_ "$2"
 458                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 459                then
 460                        test_known_broken_ok_ "$1"
 461                else
 462                        test_known_broken_failure_ "$1"
 463                fi
 464        fi
 465        echo >&3 ""
 466}
 467
 468test_expect_success () {
 469        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 470        test "$#" = 2 ||
 471        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 472        export test_prereq
 473        if ! test_skip "$@"
 474        then
 475                say >&3 "expecting success: $2"
 476                test_run_ "$2"
 477                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 478                then
 479                        test_ok_ "$1"
 480                else
 481                        test_failure_ "$@"
 482                fi
 483        fi
 484        echo >&3 ""
 485}
 486
 487test_expect_code () {
 488        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 489        test "$#" = 3 ||
 490        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
 491        if ! test_skip "$@"
 492        then
 493                say >&3 "expecting exit code $1: $3"
 494                test_run_ "$3"
 495                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 496                then
 497                        test_ok_ "$2"
 498                else
 499                        test_failure_ "$@"
 500                fi
 501        fi
 502        echo >&3 ""
 503}
 504
 505# test_external runs external test scripts that provide continuous
 506# test output about their progress, and succeeds/fails on
 507# zero/non-zero exit code.  It outputs the test output on stdout even
 508# in non-verbose mode, and announces the external script with "# run
 509# <n>: ..." before running it.  When providing relative paths, keep in
 510# mind that all scripts run in "trash directory".
 511# Usage: test_external description command arguments...
 512# Example: test_external 'Perl API' perl ../path/to/test.pl
 513test_external () {
 514        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 515        test "$#" = 3 ||
 516        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 517        descr="$1"
 518        shift
 519        export test_prereq
 520        if ! test_skip "$descr" "$@"
 521        then
 522                # Announce the script to reduce confusion about the
 523                # test output that follows.
 524                say_color "" "# run $test_count: $descr ($*)"
 525                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 526                # to be able to use them in script
 527                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 528                # Run command; redirect its stderr to &4 as in
 529                # test_run_, but keep its stdout on our stdout even in
 530                # non-verbose mode.
 531                "$@" 2>&4
 532                if [ "$?" = 0 ]
 533                then
 534                        if test $test_external_has_tap -eq 0; then
 535                                test_ok_ "$descr"
 536                        else
 537                                say_color "" "# test_external test $descr was ok"
 538                                test_success=$(($test_success + 1))
 539                        fi
 540                else
 541                        if test $test_external_has_tap -eq 0; then
 542                                test_failure_ "$descr" "$@"
 543                        else
 544                                say_color error "# test_external test $descr failed: $@"
 545                                test_failure=$(($test_failure + 1))
 546                        fi
 547                fi
 548        fi
 549}
 550
 551# Like test_external, but in addition tests that the command generated
 552# no output on stderr.
 553test_external_without_stderr () {
 554        # The temporary file has no (and must have no) security
 555        # implications.
 556        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 557        stderr="$tmp/git-external-stderr.$$.tmp"
 558        test_external "$@" 4> "$stderr"
 559        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 560        descr="no stderr: $1"
 561        shift
 562        say >&3 "# expecting no stderr from previous command"
 563        if [ ! -s "$stderr" ]; then
 564                rm "$stderr"
 565
 566                if test $test_external_has_tap -eq 0; then
 567                        test_ok_ "$descr"
 568                else
 569                        say_color "" "# test_external_without_stderr test $descr was ok"
 570                        test_success=$(($test_success + 1))
 571                fi
 572        else
 573                if [ "$verbose" = t ]; then
 574                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 575                else
 576                        output=
 577                fi
 578                # rm first in case test_failure exits.
 579                rm "$stderr"
 580                if test $test_external_has_tap -eq 0; then
 581                        test_failure_ "$descr" "$@" "$output"
 582                else
 583                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 584                        test_failure=$(($test_failure + 1))
 585                fi
 586        fi
 587}
 588
 589# debugging-friendly alternatives to "test [-f|-d|-e]"
 590# The commands test the existence or non-existence of $1. $2 can be
 591# given to provide a more precise diagnosis.
 592test_path_is_file () {
 593        if ! [ -f "$1" ]
 594        then
 595                echo "File $1 doesn't exist. $*"
 596                false
 597        fi
 598}
 599
 600test_path_is_dir () {
 601        if ! [ -d "$1" ]
 602        then
 603                echo "Directory $1 doesn't exist. $*"
 604                false
 605        fi
 606}
 607
 608test_path_is_missing () {
 609        if [ -e "$1" ]
 610        then
 611                echo "Path exists:"
 612                ls -ld "$1"
 613                if [ $# -ge 1 ]; then
 614                        echo "$*"
 615                fi
 616                false
 617        fi
 618}
 619
 620
 621# This is not among top-level (test_expect_success | test_expect_failure)
 622# but is a prefix that can be used in the test script, like:
 623#
 624#       test_expect_success 'complain and die' '
 625#           do something &&
 626#           do something else &&
 627#           test_must_fail git checkout ../outerspace
 628#       '
 629#
 630# Writing this as "! git checkout ../outerspace" is wrong, because
 631# the failure could be due to a segv.  We want a controlled failure.
 632
 633test_must_fail () {
 634        "$@"
 635        exit_code=$?
 636        if test $exit_code = 0; then
 637                echo >&2 "test_must_fail: command succeeded: $*"
 638                return 1
 639        elif test $exit_code -gt 129 -a $exit_code -le 192; then
 640                echo >&2 "test_must_fail: died by signal: $*"
 641                return 1
 642        elif test $exit_code = 127; then
 643                echo >&2 "test_must_fail: command not found: $*"
 644                return 1
 645        fi
 646        return 0
 647}
 648
 649# Similar to test_must_fail, but tolerates success, too.  This is
 650# meant to be used in contexts like:
 651#
 652#       test_expect_success 'some command works without configuration' '
 653#               test_might_fail git config --unset all.configuration &&
 654#               do something
 655#       '
 656#
 657# Writing "git config --unset all.configuration || :" would be wrong,
 658# because we want to notice if it fails due to segv.
 659
 660test_might_fail () {
 661        "$@"
 662        exit_code=$?
 663        if test $exit_code -gt 129 -a $exit_code -le 192; then
 664                echo >&2 "test_might_fail: died by signal: $*"
 665                return 1
 666        elif test $exit_code = 127; then
 667                echo >&2 "test_might_fail: command not found: $*"
 668                return 1
 669        fi
 670        return 0
 671}
 672
 673# test_cmp is a helper function to compare actual and expected output.
 674# You can use it like:
 675#
 676#       test_expect_success 'foo works' '
 677#               echo expected >expected &&
 678#               foo >actual &&
 679#               test_cmp expected actual
 680#       '
 681#
 682# This could be written as either "cmp" or "diff -u", but:
 683# - cmp's output is not nearly as easy to read as diff -u
 684# - not all diff versions understand "-u"
 685
 686test_cmp() {
 687        $GIT_TEST_CMP "$@"
 688}
 689
 690# This function can be used to schedule some commands to be run
 691# unconditionally at the end of the test to restore sanity:
 692#
 693#       test_expect_success 'test core.capslock' '
 694#               git config core.capslock true &&
 695#               test_when_finished "git config --unset core.capslock" &&
 696#               hello world
 697#       '
 698#
 699# That would be roughly equivalent to
 700#
 701#       test_expect_success 'test core.capslock' '
 702#               git config core.capslock true &&
 703#               hello world
 704#               git config --unset core.capslock
 705#       '
 706#
 707# except that the greeting and config --unset must both succeed for
 708# the test to pass.
 709
 710test_when_finished () {
 711        test_cleanup="{ $*
 712                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 713}
 714
 715# Most tests can use the created repository, but some may need to create more.
 716# Usage: test_create_repo <directory>
 717test_create_repo () {
 718        test "$#" = 1 ||
 719        error "bug in the test script: not 1 parameter to test-create-repo"
 720        repo="$1"
 721        mkdir -p "$repo"
 722        (
 723                cd "$repo" || error "Cannot setup test environment"
 724                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 725                error "cannot run git init -- have you built things yet?"
 726                mv .git/hooks .git/hooks-disabled
 727        ) || exit
 728}
 729
 730test_done () {
 731        GIT_EXIT_OK=t
 732
 733        if test -z "$HARNESS_ACTIVE"; then
 734                test_results_dir="$TEST_DIRECTORY/test-results"
 735                mkdir -p "$test_results_dir"
 736                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 737
 738                echo "total $test_count" >> $test_results_path
 739                echo "success $test_success" >> $test_results_path
 740                echo "fixed $test_fixed" >> $test_results_path
 741                echo "broken $test_broken" >> $test_results_path
 742                echo "failed $test_failure" >> $test_results_path
 743                echo "" >> $test_results_path
 744        fi
 745
 746        if test "$test_fixed" != 0
 747        then
 748                say_color pass "# fixed $test_fixed known breakage(s)"
 749        fi
 750        if test "$test_broken" != 0
 751        then
 752                say_color error "# still have $test_broken known breakage(s)"
 753                msg="remaining $(($test_count-$test_broken)) test(s)"
 754        else
 755                msg="$test_count test(s)"
 756        fi
 757        case "$test_failure" in
 758        0)
 759                # Maybe print SKIP message
 760                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 761
 762                if test $test_external_has_tap -eq 0; then
 763                        say_color pass "# passed all $msg"
 764                        say "1..$test_count$skip_all"
 765                fi
 766
 767                test -d "$remove_trash" &&
 768                cd "$(dirname "$remove_trash")" &&
 769                rm -rf "$(basename "$remove_trash")"
 770
 771                exit 0 ;;
 772
 773        *)
 774                if test $test_external_has_tap -eq 0; then
 775                        say_color error "# failed $test_failure among $msg"
 776                        say "1..$test_count"
 777                fi
 778
 779                exit 1 ;;
 780
 781        esac
 782}
 783
 784# Test the binaries we have just built.  The tests are kept in
 785# t/ subdirectory and are run in 'trash directory' subdirectory.
 786if test -z "$TEST_DIRECTORY"
 787then
 788        # We allow tests to override this, in case they want to run tests
 789        # outside of t/, e.g. for running tests on the test library
 790        # itself.
 791        TEST_DIRECTORY=$(pwd)
 792fi
 793GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 794
 795if test -n "$valgrind"
 796then
 797        make_symlink () {
 798                test -h "$2" &&
 799                test "$1" = "$(readlink "$2")" || {
 800                        # be super paranoid
 801                        if mkdir "$2".lock
 802                        then
 803                                rm -f "$2" &&
 804                                ln -s "$1" "$2" &&
 805                                rm -r "$2".lock
 806                        else
 807                                while test -d "$2".lock
 808                                do
 809                                        say "Waiting for lock on $2."
 810                                        sleep 1
 811                                done
 812                        fi
 813                }
 814        }
 815
 816        make_valgrind_symlink () {
 817                # handle only executables
 818                test -x "$1" || return
 819
 820                base=$(basename "$1")
 821                symlink_target=$GIT_BUILD_DIR/$base
 822                # do not override scripts
 823                if test -x "$symlink_target" &&
 824                    test ! -d "$symlink_target" &&
 825                    test "#!" != "$(head -c 2 < "$symlink_target")"
 826                then
 827                        symlink_target=../valgrind.sh
 828                fi
 829                case "$base" in
 830                *.sh|*.perl)
 831                        symlink_target=../unprocessed-script
 832                esac
 833                # create the link, or replace it if it is out of date
 834                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 835        }
 836
 837        # override all git executables in TEST_DIRECTORY/..
 838        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 839        mkdir -p "$GIT_VALGRIND"/bin
 840        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 841        do
 842                make_valgrind_symlink $file
 843        done
 844        OLDIFS=$IFS
 845        IFS=:
 846        for path in $PATH
 847        do
 848                ls "$path"/git-* 2> /dev/null |
 849                while read file
 850                do
 851                        make_valgrind_symlink "$file"
 852                done
 853        done
 854        IFS=$OLDIFS
 855        PATH=$GIT_VALGRIND/bin:$PATH
 856        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 857        export GIT_VALGRIND
 858elif test -n "$GIT_TEST_INSTALLED" ; then
 859        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 860        error "Cannot run git from $GIT_TEST_INSTALLED."
 861        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 862        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 863else # normal case, use ../bin-wrappers only unless $with_dashes:
 864        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 865        if ! test -x "$git_bin_dir/git" ; then
 866                if test -z "$with_dashes" ; then
 867                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 868                fi
 869                with_dashes=t
 870        fi
 871        PATH="$git_bin_dir:$PATH"
 872        GIT_EXEC_PATH=$GIT_BUILD_DIR
 873        if test -n "$with_dashes" ; then
 874                PATH="$GIT_BUILD_DIR:$PATH"
 875        fi
 876fi
 877GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 878unset GIT_CONFIG
 879GIT_CONFIG_NOSYSTEM=1
 880GIT_CONFIG_NOGLOBAL=1
 881export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 882
 883. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
 884
 885if test -z "$GIT_TEST_CMP"
 886then
 887        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 888        then
 889                GIT_TEST_CMP="$DIFF -c"
 890        else
 891                GIT_TEST_CMP="$DIFF -u"
 892        fi
 893fi
 894
 895GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 896export GITPERLLIB
 897test -d "$GIT_BUILD_DIR"/templates/blt || {
 898        error "You haven't built things yet, have you?"
 899}
 900
 901if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 902then
 903        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 904        export GITPYTHONLIB
 905        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 906                error "You haven't built git_remote_helpers yet, have you?"
 907        }
 908fi
 909
 910if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
 911        echo >&2 'You need to build test-chmtime:'
 912        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 913        exit 1
 914fi
 915
 916# Test repository
 917test="trash directory.$(basename "$0" .sh)"
 918test -n "$root" && test="$root/$test"
 919case "$test" in
 920/*) TRASH_DIRECTORY="$test" ;;
 921 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 922esac
 923test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 924rm -fr "$test" || {
 925        GIT_EXIT_OK=t
 926        echo >&5 "FATAL: Cannot prepare test area"
 927        exit 1
 928}
 929
 930test_create_repo "$test"
 931# Use -P to resolve symlinks in our working directory so that the cwd
 932# in subprocesses like git equals our $PWD (for pathname comparisons).
 933cd -P "$test" || exit 1
 934
 935HOME=$(pwd)
 936export HOME
 937
 938this_test=${0##*/}
 939this_test=${this_test%%-*}
 940for skp in $GIT_SKIP_TESTS
 941do
 942        case "$this_test" in
 943        $skp)
 944                say_color skip >&3 "skipping test $this_test altogether"
 945                skip_all="skip all tests in $this_test"
 946                test_done
 947        esac
 948done
 949
 950# Provide an implementation of the 'yes' utility
 951yes () {
 952        if test $# = 0
 953        then
 954                y=y
 955        else
 956                y="$*"
 957        fi
 958
 959        while echo "$y"
 960        do
 961                :
 962        done
 963}
 964
 965# Fix some commands on Windows
 966case $(uname -s) in
 967*MINGW*)
 968        # Windows has its own (incompatible) sort and find
 969        sort () {
 970                /usr/bin/sort "$@"
 971        }
 972        find () {
 973                /usr/bin/find "$@"
 974        }
 975        sum () {
 976                md5sum "$@"
 977        }
 978        # git sees Windows-style pwd
 979        pwd () {
 980                builtin pwd -W
 981        }
 982        # no POSIX permissions
 983        # backslashes in pathspec are converted to '/'
 984        # exec does not inherit the PID
 985        test_set_prereq MINGW
 986        ;;
 987*)
 988        test_set_prereq POSIXPERM
 989        test_set_prereq BSLASHPSPEC
 990        test_set_prereq EXECKEEPSPID
 991        test_set_prereq NOT_MINGW
 992        ;;
 993esac
 994
 995test -z "$NO_PERL" && test_set_prereq PERL
 996test -z "$NO_PYTHON" && test_set_prereq PYTHON
 997
 998# test whether the filesystem supports symbolic links
 999ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1000rm -f y
1001
1002# When the tests are run as root, permission tests will report that
1003# things are writable when they shouldn't be.
1004test -w / || test_set_prereq SANITY